"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
var _exportNames = {
  registerExtension: true,
  registerFilter: true,
  registerComponent: true,
  compile: true,
  compileH: true,
  render: true,
  renderH: true,
  taggedTmpl: true,
  htmlString: true,
  taggedTmplH: true,
  html: true,
  template: true,
  expression: true,
  css: true,
  as: true
};
Object.defineProperty(exports, "registerExtension", {
  enumerable: true,
  get: function get() {
    return _extension.registerExtension;
  }
});
Object.defineProperty(exports, "registerFilter", {
  enumerable: true,
  get: function get() {
    return _filter.registerFilter;
  }
});
Object.defineProperty(exports, "registerComponent", {
  enumerable: true,
  get: function get() {
    return _component.registerComponent;
  }
});
Object.defineProperty(exports, "compile", {
  enumerable: true,
  get: function get() {
    return _compile.compile;
  }
});
Object.defineProperty(exports, "compileH", {
  enumerable: true,
  get: function get() {
    return _compile.compileH;
  }
});
Object.defineProperty(exports, "render", {
  enumerable: true,
  get: function get() {
    return _compile.render;
  }
});
Object.defineProperty(exports, "renderH", {
  enumerable: true,
  get: function get() {
    return _compile.renderH;
  }
});
Object.defineProperty(exports, "taggedTmpl", {
  enumerable: true,
  get: function get() {
    return _taggedTmpl.taggedTmpl;
  }
});
Object.defineProperty(exports, "htmlString", {
  enumerable: true,
  get: function get() {
    return _taggedTmpl.taggedTmpl;
  }
});
Object.defineProperty(exports, "taggedTmplH", {
  enumerable: true,
  get: function get() {
    return _taggedTmpl.taggedTmplH;
  }
});
Object.defineProperty(exports, "html", {
  enumerable: true,
  get: function get() {
    return _taggedTmpl.taggedTmplH;
  }
});
Object.defineProperty(exports, "template", {
  enumerable: true,
  get: function get() {
    return _taggedTmpl.template;
  }
});
Object.defineProperty(exports, "expression", {
  enumerable: true,
  get: function get() {
    return _taggedTmpl.expression;
  }
});
Object.defineProperty(exports, "css", {
  enumerable: true,
  get: function get() {
    return _taggedTmpl.css;
  }
});
Object.defineProperty(exports, "as", {
  enumerable: true,
  get: function get() {
    return _tools.as;
  }
});
exports["default"] = void 0;

var _core = _interopRequireDefault(require("./core"));

require("./utils/createTmplRule");

require("./config");

require("./utils/escape");

var _extension = require("./helpers/extension");

var _filter = require("./helpers/filter");

var _component = require("./helpers/component");

var _compile = require("./compiler/compile");

var _taggedTmpl = require("./utils/taggedTmpl");

var _interface = require("./interface");

Object.keys(_interface).forEach(function (key) {
  if (key === "default" || key === "__esModule") return;
  if (Object.prototype.hasOwnProperty.call(_exportNames, key)) return;
  Object.defineProperty(exports, key, {
    enumerable: true,
    get: function get() {
      return _interface[key];
    }
  });
});

var _tools = require("./utils/tools");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

var _global = _core["default"].global;
_global.NornJ = _global.nj = _core["default"];
var _default = _core["default"];
exports["default"] = _default;