"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.config = config;

var _core = _interopRequireDefault(require("./core"));

var _tools = require("./utils/tools");

var _createTmplRule = require("./utils/createTmplRule");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function config(configs) {
  var delimiters = configs.delimiters,
      includeParser = configs.includeParser,
      createElement = configs.createElement,
      outputH = configs.outputH,
      textMode = configs.textMode,
      noWsMode = configs.noWsMode,
      fixTagName = configs.fixTagName;

  if (delimiters) {
    (0, _createTmplRule.createTmplRule)(delimiters, true);
  }

  if (includeParser) {
    _core["default"].includeParser = includeParser;
  }

  if (createElement) {
    _core["default"].createElement = createElement;
  }

  if (outputH != null) {
    _core["default"].outputH = outputH;
  }

  if (textMode != null) {
    _core["default"].textMode = textMode;
  }

  if (noWsMode != null) {
    _core["default"].noWsMode = noWsMode;
  }

  if (fixTagName != null) {
    _core["default"].fixTagName = fixTagName;
  }
}

(0, _tools.assign)(_core["default"], {
  config: config
});